import 'dart:async';
import 'dart:io';

import 'package:collection/collection.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:syncfusion_flutter_gauges/gauges.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/xfxbase.dart';
import 'package:xfxwidgets/XF_MAIN/XAppState.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:animation_list/animation_list.dart';
import 'package:curved_navigation_bar/curved_navigation_bar.dart';

import '../XTabItem.dart';
import 'XApp.dart';
import 'XArea.dart';

class XMainPage_Base<T> extends StatefulWidget {
  XMainPage_Base(this.xApp, {Key? key, this.title, this.logOUT_Active, this.bottomArea_Widget}) : super(key: key);
  String? title;
  bool? logOUT_Active;
  Widget? bottomArea_Widget;
  late XApp xApp;

  @override
  XMainPage_BaseState<T> createState() => XMainPage_BaseState<T>();
}

class XMainPage_BaseState<T> extends State<XMainPage_Base<T>> with TickerProviderStateMixin {
  // GlobalKey<ScaffoldState> scaffoldKey_MainMenu = GlobalKey<ScaffoldState>();
  List<XMenuItem> liMenuItems = List<XMenuItem>.empty(growable: true);
  late TabController? tabController;
  bool menuPinned = true;
  bool syncWithServer = false;
  late List<String> liKeys_MenuItem = List<String>.empty(growable: true);
  List<XAction> liFastXActions_ToView = List<XAction>.empty(growable: true);
  bool snackBar_Visible = false;
  @override
  void initState() {
    widget.logOUT_Active = widget.xApp.authentication;
    tabController = getTabController();
    xOnLoadPermissions();
    liFastXActions_ToView = widget.xApp.state.liXActions.where((element) => element.fastAction ?? false).toList();
    super.initState();
  }

  List<String>? get_liKeysForMenu() {
    return null;
  }

  xOnLoadPermissions() {
    var res = get_liKeysForMenu();
    if (res != null) {
      for (var i in widget.xApp.liXMenus) {
        i.items.forEach((element) {
          if (res.any((key) => key == element.key)) {
            liMenuItems.add(element);
          }
        });
      }

      widget.xApp.liXMenus.forEach((menugrp) {
        menugrp.items = List<XMenuItem>.unmodifiable(liMenuItems);
      });
    }
  }

  TabController getTabController() {
    return TabController(length: widget.xApp.state.li_XAree.length, vsync: this);
  }

  updateTabController() {
//    tabController = TabController(length: widget.li_XAree!.length, vsync: this);
    tabController = TabController(length: widget.xApp.state.li_XAree.length, vsync: this);

    setState(() {
      print(tabController!.index.toString());
      tabController!.index = widget.xApp.state.li_XAree.firstWhere((element) => element.key_Area == widget.xApp.state.area_Active.key_Area).idx_Area;
      print(tabController!.index.toString());
    });
  }

  @override
  void dispose() {
    tabController!.dispose();
    super.dispose();
  }

  signOut() {
    SharedPreferences.getInstance().then((prefs) {
      prefs.clear();
    });
    Navigator.pushNamed(context, widget.xApp.state.PgName_Login);
  }

  Future<bool> warnLogOff(BuildContext context) async {
    var rval = await showDialog<bool>(
        context: context,
        builder: (c) => AlertDialog(
              title: Text('Attenzione', textAlign: TextAlign.center, style: TextStyle(color: Colors.yellow)),
              content: Text('Sei sicuro di disconnetterti?'),
              actions: [
                TextButton(style: TextButton.styleFrom(foregroundColor: Colors.green), onPressed: () => Navigator.pop(c, true), child: Text('Si')),
                TextButton(style: TextButton.styleFrom(foregroundColor: Colors.red), onPressed: () => Navigator.pop(c, false), child: Text('No')),
              ],
            ));
    return rval ?? false;
  }

  @override
  Widget build(BuildContext context) {
    // return Consumer<T>(builder: (context, xApp.state, _) {
    // menuPinned = (MediaQuery.of(context).size.width > XUtils.widthMin_Layout);

    return _buildPageLayout(context);
    // });
  }

  int lastTabIdx = -1;
  checkActive_Area(XMenuItem item) {
    var x = widget.xApp.state.li_XAree.firstWhereOrNull((element) => element.key_Area == item.key);
    if (x != null) {
      widget.xApp.state.area_Active = x;
    } else {
      lastTabIdx++;
      var xclArea = XArea(
        item.key,
        lastTabIdx,
        widget.xApp.getWidget_FormMenuItem(item),
        color_Area: item.color_BTN,
        imageIcon_Area: item.image_Icon_BTN,
        label_Area: item.label,
        icon_Area: item.icon_BTN,
        color_AppBar: item.label_Color,
      );

      widget.xApp.state.li_XAree.add(xclArea);
      widget.xApp.state.area_Active = xclArea;
    }
    widget.xApp.state.scaffoldKey_MainMenu.currentState!.closeDrawer();

    setState(() {
      MediaQuery.of(context).size.width < XUtils.widthMin_Layout
          ? (menuPinned = false)
          : menuPinned
              ? (widget.xApp.state.scaffoldKey_MainMenu.currentState!.closeDrawer())
              : (menuPinned = false);
    });
  }

  getWidget_Area(XMenuItem item) {
    return Container();
  }

  KforScale_UI_edit() async {
    double _currentValue = (widget.xApp.KforScale * 100).round().toDouble();
    double _minValue = 70;
    double _maxValue = 200;
    double _firstMarkerSize = 10;
    // String _annotationValue = '100';
    var res = await showDialog<bool?>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            double width = MediaQuery.of(context).size.width;

            //Da modificare per fare i font
            void handlePointerValueChanged(double value) {
              setState(() {
                _currentValue = value.round().toDouble();
              });
            }

            /// Pointer dragging is canceled when dragging pointer value is less than 7.
            void handlePointerValueChanging(ValueChangingArgs args) {
              if (args.value < _minValue || args.value > _maxValue) {
                args.cancel = true;
              }
            }

            return Container(
                margin: EdgeInsets.symmetric(horizontal: 20),
                child: XAlertDialog(
                    colorBackGround: Colors.grey[900],
                    height: MediaQuery.of(context).size.height / 2,
                    title_Text: "Scegli la tua grandezza del testo:",
                    title_Style: XStyles.xStyleText(fontSize: 18 * (_currentValue / 100) / widget.xApp.KforScale),
                    content_insetPadding: EdgeInsets.all(0),
                    btnYES_label: "Salva",
                    btnNO_label: "Annulla",
                    child: Column(children: <Widget>[
                      Expanded(
                        flex: 7,
                        child: SfRadialGauge(axes: <RadialAxis>[
                          RadialAxis(
                            minimum: _minValue, maximum: _maxValue,
                            axisLineStyle: const AxisLineStyle(thickness: 0.2, thicknessUnit: GaugeSizeUnit.factor),
                            showTicks: false,
                            showLastLabel: true,
                            //style delle tacchette interne
                            axisLabelStyle: GaugeTextStyle(color: XColors.foregroundLight, fontSize: 18),
                            onAxisTapped: handlePointerValueChanged,
                            pointers: <GaugePointer>[
                              //streiscia da tappare e fare lo slide
                              RangePointer(
                                value: _currentValue,
                                onValueChanged: handlePointerValueChanged,
                                onValueChangeEnd: handlePointerValueChanged,
                                onValueChanging: handlePointerValueChanging,
                                enableDragging: true,
                                width: 0.2,
                                sizeUnit: GaugeSizeUnit.factor,
                              ),
                              //Pallino bianco dentro la striscia da tappare
                              MarkerPointer(
                                value: _currentValue,
                                color: Colors.white,
                                markerHeight: _firstMarkerSize,
                                markerWidth: _firstMarkerSize,
                                markerType: MarkerType.circle,
                              ),
                            ],
                            //Percentuale interna allo slider
                            annotations: <GaugeAnnotation>[
                              GaugeAnnotation(
                                  widget: Row(
                                    mainAxisSize: MainAxisSize.min,
                                    children: <Widget>[Text('${_currentValue.toInt()} %', style: XStyles.xStyTextForSubDescr())],
                                  ),
                                  positionFactor: 0.13,
                                  angle: 0)
                            ],
                          )
                        ]),
                      ),
                      //Slider orizzontale sotto alla chart
                      Expanded(
                          flex: 3,
                          child: SizedBox(
                            width: width - 50,
                            child: Slider(
                              min: _minValue,
                              max: _maxValue,
                              activeColor: const Color(0xFF02AAB0),
                              inactiveColor: const Color(0xFF00CDAC),
                              onChanged: handlePointerValueChanged,
                              value: _currentValue,
                            ),
                          )),
                    ]),
                    btnYES_OnPressed: () {
                      Navigator.pop(context, true);
                    },
                    btnNO_OnPressed: () {
                      Navigator.pop(context, false);
                    }));
          });
        });
    if (res != null && res) {
      setState(() {
        widget.xApp.KforScale = _currentValue / 100;
      });
      var prefs = await SharedPreferences.getInstance();
      prefs.setString("fontSize", widget.xApp.KforScale.toString());
    }
  }

  Future syncronizeDataFromServer() async {}

  xBuilder_XMenu(Function() tabController, Function() onPinned, bool pinned_Value) {
    return XfxMenu(
      widget.xApp.liXMenus, tabController,
      KforScale_UI_edit,
      logOut_Visible: widget.logOUT_Active,
      bottomArea_Widget: widget.bottomArea_Widget,
      firstSessionIsView: widget.xApp.state.area_Active.key_Area != "",
      snackBar_Visible: snackBar_Visible,
      functOnSync: syncWithServer == false
          ? () async {
              setState(() {
                syncWithServer = true;
              });
              await syncronizeDataFromServer().then((value) async {
                setState(() {
                  snackBar_Visible = true;
                });
                await Timer(Duration(seconds: 2), () {
                  setState(() {
                    snackBar_Visible = false;
                  });
                });
              });
              ;
              setState(() {
                syncWithServer = false;
              });

              // XAlertDialog.alertClose(context, titleText: "Aggiornati con successo i dati dal server", titleStyle: XStyles.xStyTextForSubLabel(XColors.warning));
            }
          : null,
      title: widget.title,

      xApp: widget.xApp,
      padding: EdgeInsets.symmetric(vertical: 10),
      logOut_OnTap: () async {
        var x = await warnLogOff(context);
        if (x) {
          if (widget.xApp.state.area_Active.key_Area != "") {
            Navigator.pop(context);
            Navigator.pop(context);
          } else {
            Navigator.pop(context);
          }
        }
      },
      title_Style: XStyles.xStyTextForLargeTitle(Colors.white),
      menu_BackGroundColor: Colors.grey[900],
      onPressed_PinnedBTN: () {
        if (widget.xApp.state.li_XAree.isEmpty) {
        } else {
          onPinned();
        }
      },
      pinned_Value: pinned_Value,
      syncWithServer: syncWithServer,
      onPressed_MenuItem: (i) => widget.xApp.state.homeLayoutComplex ? null : checkActive_Area(i),
      // nameApp: Text(sex.app_Name, style: XStyles.xStyTextForLabel()),
    );
  }

  Widget _buildTile(XMenuItem item) {
    return InkWell(
        onTap: () {}, //Navigator.pushNamed(context, "PgName_El_" + item.key),
        child: Container(
            height: 120,
            width: 140,
            margin: EdgeInsets.symmetric(horizontal: 10, vertical: 5),
            decoration: BoxDecoration(borderRadius: BorderRadius.all(Radius.circular(10)), color: Colors.transparent, border: Border.all(color: item.label_Color ?? widget.xApp.app_MainColor!, width: 2)),
            child: Column(children: [
              SizedBox(height: 7),
              item.image_Icon_BTN != null ? Image.memory(item.image_Icon_BTN!, width: 50, height: 50) : Container(),
              SizedBox(height: 10),
              Text(
                item.label ?? "",
                textAlign: TextAlign.center,
                style: XStyles.xStyTextForDescr(Colors.white, true),
              ),
              SizedBox(height: 5)
            ])));
  }

  Widget _xBTNforBottomBar(
    String? label, {
    String? icon_AssetPath,
    Uint8List? icon_Image,
    IconData? icon,
    double icon_Size = 30,
    Color? icon_Color,
    Color? label_Color,
    TextStyle? label_Style,
  }) {
    return InkWell(
        child: Column(mainAxisSize: MainAxisSize.min, children: [
      (icon_AssetPath != null || icon_Image != null || icon_Image != null)
          ? Row(children: [
              Expanded(
                  child: icon_AssetPath != null
                      ? Image.asset(icon_AssetPath, height: icon_Size)
                      : icon_Image != null
                          ? Image.memory(icon_Image, height: icon_Size)
                          : icon != null
                              ? Icon(icon, size: icon_Size, color: icon_Color ?? Colors.white)
                              : Container())
            ])
          : Container(),
      Row(children: [Expanded(child: FittedBox(fit: BoxFit.scaleDown, child: Text(label ?? "", style: label_Style ?? XStyles.xStyTextForSubDescr(icon_Color ?? label_Color ?? Colors.white), textAlign: TextAlign.center)))]),
    ]));
  }

  _buildPageLayout(BuildContext context) {
    return WillPopScope(
        ////////////////
        onWillPop: () async {
          widget.xApp.state.scaffoldKey_MainMenu.currentState!.openDrawer();
          return false;
        },
        /////////////////////
        child: Scaffold(
          backgroundColor: Colors.black,
          key: widget.xApp.state.scaffoldKey_MainMenu,
          appBar: widget.xApp.state.homeLayoutComplex
              ? AppBar(
                  iconTheme: IconThemeData(color: widget.xApp.app_MainColor ?? XColors.foregroundDark),
                  title: Text(((widget.title ?? "").replaceAll("App", "")), style: XStyles.xStyTextForLabel(widget.xApp.app_MainColor ?? XColors.foregroundDark)),
                  backgroundColor: Colors.grey[900],
                  centerTitle: true,
                  automaticallyImplyLeading: true,
                )
              : null,

          /// X AREA CONTAINER
          body: Container(
              margin: EdgeInsets.only(top: MediaQuery.of(context).size.height < 500 ? 40 : 0),
              child: Row(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  (MediaQuery.of(context).size.width < XUtils.widthMin_Layout)
                      ? Container()
                      : (menuPinned.not() && widget.xApp.state.homeLayoutComplex.not()
                          ? XBtnbase(
                              label: "M\nE\nN\nU",
                              width: 30,
                              decoration: BoxDecoration(color: Colors.grey[800], border: Border.all(color: Colors.white, width: 2)),
                              height: MediaQuery.of(context).size.height,
                              label_Color: Colors.white,
                              onPressed: () {
                                widget.xApp.state.scaffoldKey_MainMenu.currentState!.openDrawer();
                              },
                            )
                          : Container()),
                  menuPinned && widget.xApp.state.homeLayoutComplex.not()
                      ? xBuilder_XMenu(updateTabController, () {
                          if (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) {
                            setState(() {
                              menuPinned = false;
                            });
                          } else {
                            setState(() {
                              menuPinned = !menuPinned;
                            });
                          }
                          widget.xApp.state.scaffoldKey_MainMenu.currentState!.closeDrawer();
                        }, menuPinned)
                      : Container(),
                  SizedBox(width: MediaQuery.of(context).size.width < XUtils.widthMin_Layout ? 0 : 10),
                  Expanded(
                      flex: 15,
                      child: syncWithServer
                          ? widget.xApp.state.area_Active.key_Area != ""
                              ? XStatefulWidgetBase.LoaderIndicator(syncWithServer, label: "...caricamento dei dati...")
                              : Container()
                          : Platform.isAndroid && widget.xApp.state.homeLayoutComplex
                              ? AnimationList(
                                  duration: 1000,
                                  reBounceDepth: 10.0,
                                  padding: EdgeInsets.only(top: 5),
                                  children: widget.xApp.liXMenus
                                      .map((itemGRP) => Container(
                                              child: Column(
                                            children: [
                                              Row(children: [Expanded(child: Text(itemGRP.label ?? "", style: XStyles.xStyTextForLabel(itemGRP.label_Color ?? Colors.white), textAlign: TextAlign.center))]),
                                              Wrap(crossAxisAlignment: WrapCrossAlignment.center, children: itemGRP.items.map((e) => _buildTile(e)).toList()),
                                            ],
                                          )))
                                      .toList(),
                                )
                              : (widget.xApp.state.li_XAree.length < 2)
                                  ? (widget.xApp.state.li_XAree.isNotEmpty)
                                      ? widget.xApp.state.li_XAree.firstWhere((element) => element.key_Area == widget.xApp.state.area_Active.key_Area).widget_Area ?? Container()
                                      : Container()
                                  : MediaQuery.of(context).size.width < XUtils.widthMin_Layout
                                      ? widget.xApp.state.area_Active.widget_Area ?? Container()
                                      : XfxArea(
                                          widget.xApp,
                                          tabController: tabController,
                                          margin_Horizontal: 0,
                                          tapOnTab: (idx) {
                                            widget.xApp.state.area_Active = widget.xApp.state.li_XAree.firstWhere((element) => element.idx_Area == idx);
                                          },
                                          tabs_BackGroundColor: Colors.transparent,
                                          title_Visible: false,
                                          bottomBar_Visible: false,
                                          numberOfTabs: widget.xApp.state.li_XAree.length,
                                          isScrollableTabs: false,
                                          children: widget.xApp.state.li_XAree.map((x) {
                                            return x.widget_Area ?? Container();
                                          }).toList(),
                                          tabs: widget.xApp.state.li_XAree
                                              .map((e) => XTabItem(
                                                    e.idx_Area,
                                                    e.key_Area,
                                                    e.label_Area ?? "No Label",
                                                    image_Icon: e.imageIcon_Area,
                                                    icon: e.icon_Area ?? Icons.warning,
                                                    color_backGroundTab: Colors.grey[900],
                                                    color_backGroundTab_Activate: e.color_AppBar!.withAlpha(40),
                                                    labelColor_Disabled: XColors.foregroundLight,
                                                    labelColor_Active: e.color_AppBar,
                                                    iconColor_Active: e.color_AppBar,
                                                    iconColor_Disabled: XColors.foregroundLight,
                                                  ))
                                              .toList(),
                                        )),
                ],
              )),
          ///////////////////// MENU
          bottomNavigationBar: widget.xApp.state.homeLayoutComplex && liFastXActions_ToView.isNotEmpty
              ? Container(
                  width: MediaQuery.of(context).size.width,
                  child: CurvedNavigationBar(
                    height: 60,
                    backgroundColor: Colors.transparent,
                    color: widget.xApp.app_MainColor!,
                    buttonBackgroundColor: widget.xApp.app_MainColor!,
                    items: liFastXActions_ToView
                        .map((e) => _xBTNforBottomBar(
                              e.label,
                              icon_Image: e.icon_Image,
                              icon_Color: e.icon_Color!,
                              label_Color: e.label_Color,
                            ))
                        .toList(),
                    onTap: (index) {
                      var res = liFastXActions_ToView.firstWhereOrNull((element) => element.idx == index);
                      if (res != null) {
                        if (res.cmd != null) {
                          res.cmd!(null);
                        }
                      }
                    },
                  ))
              : null,
          drawer: menuPinned.not() || widget.xApp.state.homeLayoutComplex
              ? xBuilder_XMenu(updateTabController, () {
                  if (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) {
                    setState(() {
                      menuPinned = false;
                    });
                  } else {
                    setState(() {
                      menuPinned = !menuPinned;
                    });
                  }
                  widget.xApp.state.scaffoldKey_MainMenu.currentState!.closeDrawer();
                }, menuPinned)
              : null,
        ));
  }
}
